/**
 * ### Тип линка
 *
 * Этот менеджер позволяет запросить данные по типу линка.
 *
 * ```bash
 * // доступ
 * ps.pl.ltm
 * ```
 *
 * <br>
 * Связанные объекты:
 *
 * - {@link LinkTypes.LinkType LinkType} - Тип группы
 *
 * @group manager
 * @namespace LinkTypes
 */
function LinkTypes() {
    /**
     *  Вернет ссылку на Тип линка.
     *
     *
     * Пример
     * ```
     * // компонентом может быть например tunnel
     * ps.pl.ltm.get(new v2.model_type("tunnel")).then(function(_ref){
     *     var provider = _ref.value();
     *     // теперь можно работать с провайдером типа линка
     * }, function(_err){
     *     console.log("произошла ошибка")
     * });
     * ```
     *
     * @public
     * @function get
     * @memberof LinkTypes
     * @param {v2.model_type} _linkType Тип линка
     * @returns {tools.promise(LinkTypes.LinkType)}
     */
    this.get = function (_linkType) {

    };
}