/** @typedef {Links.Link.Attributes} LinkAttributes */
/** @typedef {Links.Link.Attributes.Attribute} LinkAttribute */

/**
 *
 * * ### Менеджер атрибутов линка
 * Предоставляет данные о линке.
 * У него можно запросить его атрибутный состав
 *
 * <br>
 * Связанные объекты:
 *
 * - {@link Links} - Менеджер предоставляющий доступ к данным о линках
 * - {@link Links.Link} - Модель линка
 * - {@link Links.Link.Attributes.Attribute} - Модель атрибута линка
 *
 * @group manager
 * @class Attributes
 * @memberof Links.Link
 */
function Attributes() {
    /**
     * Возвращает список атрибутов линка
     *
     * @public
     * @function attributes
     * @returns {v2.map(v2.string, v2.vc)}
     * @memberof Links.Link.Attributes
     */
    this.attributes = function() {

    };

    /**
     * Возвращает ссылку на атрибут линка
     *
     * @public
     * @function get
     * @param {v2.string} attributeName
     * @returns {tools.promise}
     * @memberof Links.Link.Attributes
     */
    this.get = function(attributeName) {

    };
}